/************************************************************************ 
  Copyright 2011-2012, IceJS Team. All rights reserved.
  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are
  met:
  
      * Redistributions of source code must retain the above copyright
        notice, this list of conditions and the following disclaimer.
      * Redistributions in binary form must reproduce the above
        copyright notice, this list of conditions and the following
        disclaimer in the documentation and/or other materials provided
        with the distribution.
      * Neither the name of Update Freezer Team nor the names of its
        contributors may be used to endorse or promote products derived
        from this software without specific prior written permission.
  
  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************************/
 
if (typeof(Util) == "undefined")
	Util = {};
	
Util.Registry = 
{
	HKCR: "HKEY_CLASSES_ROOT",
	HKCU: "HKEY_CURRENT_USER",
	HKLM: "HKEY_LOCAL_MACHINE",
	HKU: "HKEY_USERS",
	HKPD: "HKEY_PERFORMANCE_DATA",
	HKCC: "HKEY_CURRENT_CONFIG",
	
	GetKeyValueString: function(section, keyPath, keyName)
	{
		return _QueryRegistryKeyValueString(section, keyPath, keyName);
	},
	
	GetKeyValueDWORD: function(section, keyPath, keyName)
	{
		return _QueryRegistryKeyValueDWORD(section, keyPath, keyName);
	},
	
	SetKeyValueDWORD: function(section, path, valName, valData) /**Boolean*/
	{
		return _SetRegistryKeyValueDWORD(section, path, valName, valData);
	},

	// if key does not exiss - we will create it
	SetKeyValueString: function(section, path, valName, valData) /**Boolean*/
	{
		return _SetRegistryKeyValueString(section, path, valName, valData);
	},
	
	DeleteKeyValue: function(section, path, valName) /**Boolean*/
	{
		return _DeleteRegistryValue(section, path, valName);
	},
	
	IsKeyValueExists: function(section, path, valName) /**Boolean*/
	{
		return _IsRegistryKeyValueExists(section, path, valName);
	},
	
	IsKeyExists: function(section, path) /**Boolean*/
	{
		return _IsRegistryKeyExists(section, path);
	},
	
	// creates path if it does not exist
	EnsureKeyExists: function(section, path)
	{
		if(!_IsRegistryKeyExists(section, path))
		{
			if(!_CreateRegistryKey(section, path))
				return false;
		}
		return true;
	},
	
	EnumChildrenKeyNames: function(section, path)
	{
		return _RegEnumChildrenKeyNames(section, path);
	}
}